package com.logicbig.example;

import org.springframework.context.annotation.*;

@Configuration
@ComponentScan(basePackageClasses = ScanConfigurationExample.class, useDefaultFilters = false,
                    includeFilters = {@ComponentScan.Filter(
                                        type = FilterType.ASSIGNABLE_TYPE,
                                        value = ScanConfigurationExample.TestBean.class)})
public class ScanConfigurationExample {

    public static void main (String[] args) {
        AnnotationConfigApplicationContext context =
                            new AnnotationConfigApplicationContext(
                                                ScanConfigurationExample.class);
        MyBean bean = context.getBean(MyBean.class);
        System.out.println(bean);

        //accessing multiple times
        bean = context.getBean(MyBean.class);
        System.out.println(bean);

        /*this will return same instance because @Configuration classes even in scan path will be
        * CGLIB proxied*/
        TestBean testBean = context.getBean(TestBean.class);
        System.out.println(testBean.myBean());
    }

    @Configuration
    static class TestBean {
        @Bean
        public MyBean myBean () {
            return new MyBean();
        }
    }
}