package com.logicbig.example;

import org.springframework.context.annotation.*;
import org.springframework.stereotype.Component;

@Configuration
@ComponentScan(basePackageClasses = ScanFactoryComponentExample.class, useDefaultFilters = false,
                    includeFilters = {@ComponentScan.Filter(
                                        type = FilterType.ASSIGNABLE_TYPE,
                                        value = ScanFactoryComponentExample.TestBean.class)})
public class ScanFactoryComponentExample {

    public static void main (String[] args) {
        AnnotationConfigApplicationContext context =
                            new AnnotationConfigApplicationContext(
                                                ScanFactoryComponentExample.class);
        MyBean bean = context.getBean(MyBean.class);
        System.out.println(bean);

        //accessing multiple times
        bean = context.getBean(MyBean.class);
        System.out.println(bean);

        /*this will return a new instance because @Component methods are not
        * CGLIB proxied*/
        TestBean testBean = context.getBean(TestBean.class);
        System.out.println(testBean.myBean());
    }

    @Component
     static class TestBean {
        @Bean
        public MyBean myBean () {
            return new MyBean();
        }
    }
}